// CntrItem.h : interface of the CMKCntrItem class
//

#pragma once

class CMKDoc;
class CMKView;

class CMKCntrItem : public COleClientItem
{
	DECLARE_SERIAL(CMKCntrItem)

// Constructors
public:
	CMKCntrItem(CMKDoc* pContainer = NULL);
		// Note: pContainer is allowed to be NULL to enable IMPLEMENT_SERIALIZE
		//  IMPLEMENT_SERIALIZE requires the class have a constructor with
		//  zero arguments.  Normally, OLE items are constructed with a
		//  non-NULL document pointer

// Attributes
public:
	CMKDoc* GetDocument()
		{ return reinterpret_cast<CMKDoc*>(COleClientItem::GetDocument()); }
	CMKView* GetActiveView()
		{ return reinterpret_cast<CMKView*>(COleClientItem::GetActiveView()); }

	public:
	virtual void OnChange(OLE_NOTIFICATION wNotification, DWORD dwParam);
	virtual void OnActivate();
	protected:
	virtual void OnGetItemPosition(CRect& rPosition);
	virtual void OnDeactivateUI(BOOL bUndoable);
	virtual BOOL OnChangeItemPosition(const CRect& rectPos);

// Implementation
public:
	~CMKCntrItem();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	virtual void Serialize(CArchive& ar);
};

