// MKDoc.cpp : implementation of the CMKDoc class
//

#include "stdafx.h"
#include "MK.h"

#include "MKDoc.h"
#include "CntrItem.h"
#include "MKView.h" 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMKDoc

IMPLEMENT_DYNCREATE(CMKDoc, COleDocument)

BEGIN_MESSAGE_MAP(CMKDoc, COleDocument)
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, COleDocument::OnUpdatePasteMenu)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_LINK, COleDocument::OnUpdatePasteLinkMenu)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_CONVERT, COleDocument::OnUpdateObjectVerbMenu)
	ON_COMMAND(ID_OLE_EDIT_CONVERT, COleDocument::OnEditConvert)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, COleDocument::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, COleDocument::OnEditLinks)
	ON_UPDATE_COMMAND_UI_RANGE(ID_OLE_VERB_FIRST, ID_OLE_VERB_LAST, COleDocument::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CMKDoc, COleDocument)
END_DISPATCH_MAP()

// Note: we add support for IID_IMK to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .IDL file.

// {1A5C4645-A943-405E-BA78-B3465F387F22}
static const IID IID_IMK =
{ 0x1A5C4645, 0xA943, 0x405E, { 0xBA, 0x78, 0xB3, 0x46, 0x5F, 0x38, 0x7F, 0x22 } };

BEGIN_INTERFACE_MAP(CMKDoc, COleDocument)
	INTERFACE_PART(CMKDoc, IID_IMK, Dispatch)
END_INTERFACE_MAP()


// CMKDoc construction/destruction

CMKDoc::CMKDoc()
{
	// Use OLE compound files
	EnableCompoundFile();

	// TODO: add one-time construction code here

	EnableAutomation();

	AfxOleLockApp();
}

CMKDoc::~CMKDoc()
{
	AfxOleUnlockApp();
}

BOOL CMKDoc::OnNewDocument()
{
	if (!COleDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}




// CMKDoc serialization

void CMKDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		POSITION pos = GetFirstViewPosition();
		CMKView* pView = (CMKView*)GetNextView(pos);
		pView->LinesCoord1.Serialize(ar);
		pView->LinesCoord05.Serialize(ar);
		pView->TextCoord.Serialize(ar);
		pView->Text.Serialize(ar);
	}
	else
	{
		// TODO: add loading code here
		POSITION pos = GetFirstViewPosition();
		CMKView* pView = (CMKView*)GetNextView(pos);
		pView->LinesCoord1.RemoveAll();
		pView->LinesCoord05.RemoveAll();
		pView->Text.RemoveAll();
		pView->TextCoord.RemoveAll();
		pView->LinesCoord1.Serialize(ar);
		pView->LinesCoord05.Serialize(ar);
		pView->TextCoord.Serialize(ar);
		pView->Text.Serialize(ar);
	}

	// Calling the base class COleDocument enables serialization
	//  of the container document's COleClientItem objects.
	COleDocument::Serialize(ar);
}


// CMKDoc diagnostics

#ifdef _DEBUG
void CMKDoc::AssertValid() const
{
	COleDocument::AssertValid();
}

void CMKDoc::Dump(CDumpContext& dc) const
{
	COleDocument::Dump(dc);
}
#endif //_DEBUG


// CMKDoc commands

BOOL CMKDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	if (!COleDocument::OnOpenDocument(lpszPathName))
		return FALSE;

	// TODO:  Add your specialized creation code here

	return TRUE;
}
